//
//  MessagePack.m
//  msgpack-objc-ios
//
//  Created by akisute on 11/10/15.
//  Copyright (c) 2011年 akisute. All rights reserved.
//


#import "MessagePack.h"

#import "MessagePackPacker.h"
#import "MessagePackUnpacker.h"


@interface MessagePack ()
@property (nonatomic, strong, readonly) MessagePackPacker *packer;
@property (nonatomic, strong, readonly) MessagePackUnpacker *unpacker;
@end


#pragma mark -


@implementation MessagePack


@synthesize packer = _packer;
@synthesize unpacker = _unpacker;

- (MessagePackPacker *)packer
{
    if (_packer == nil) {
        _packer = [[MessagePackPacker alloc] init];
    }
    return _packer;
}
- (MessagePackUnpacker *)unpacker
{
    if (_unpacker == nil) {
        _unpacker = [[MessagePackUnpacker alloc] init];
    }
    return _unpacker;
}


#pragma mark - Init/dealloc


+ (MessagePack *)messagePack
{
    return [[self alloc] init];
}


#pragma mark - Serializing


- (NSData *)packToData:(id)object
{
    return nil;
}


#pragma mark - Deserializing


- (id)unpackData:(NSData *)data
{
    return [self.unpacker unpackData:data];
}

@end
