//
//  msgpack_objcGHUnitAsyncTests.m
//  msgpack-objc
//
//  Created by 小野 将司 on 12/01/21.
//  Copyright (c) 2012年 akisute. All rights reserved.
//

#import "msgpack_objcGHUnitAsyncTests.h"

@implementation msgpack_objcGHUnitAsyncTests

- (void)testNSURLConnection_iOS5
{
    [self prepare:_cmd];
    NSURLRequest *request = [NSURLRequest requestWithURL:[NSURL URLWithString:@"http://www.google.com"]];
    [NSURLConnection sendAsynchronousRequest:request
                                       queue:[NSOperationQueue mainQueue]
                           completionHandler:^(NSURLResponse *response, NSData *data, NSError *error) {
                               if (error) {
                                   GHTestLog(@"Request failed with error: %@", error);
                                   [self notify:kGHUnitWaitStatusFailure forSelector:_cmd];
                                   return;
                               }
                               [self notify:kGHUnitWaitStatusSuccess forSelector:_cmd];
                           }];
    [self waitForStatus:kGHUnitWaitStatusSuccess timeout:10.0];
}

- (void)testNSURLConnection_iOS2
{
    [self prepare:_cmd];
    NSURLRequest *request = [NSURLRequest requestWithURL:[NSURL URLWithString:@"http://www.google.com"]];
    [NSURLConnection connectionWithRequest:request delegate:self];
    [self waitForStatus:kGHUnitWaitStatusSuccess timeout:10.0];
}

- (void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response
{
    // Check the response object (MIME, length, anything else)
}
- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data
{
    // Build up the received data into the buffer
}

- (void)connectionDidFinishLoading:(NSURLConnection *)connection
{
    [self notify:kGHUnitWaitStatusSuccess forSelector:@selector(testNSURLConnection_iOS2)];
}

- (void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error
{
    GHTestLog(@"Request failed with error: %@", error);
    [self notify:kGHUnitWaitStatusFailure forSelector:@selector(testNSURLConnection_iOS2)];
}

@end
