//
//  MessagePackTest.m
//  msgpack-objc
//
//  Created by 小野 将司 on 12/01/08.
//  Copyright (c) 2012年 akisute. All rights reserved.
//

#import "MessagePackTest.h"
#import "MessagePack.h"


@implementation MessagePackTest

- (void)testInitializing
{
    MessagePack *messagePack = [MessagePack messagePack];
    STAssertNotNil(messagePack, @"messagePack instance should be obtained.");
    
    MessagePack *anotherMessagePack = [MessagePack messagePack];
    STAssertFalse(messagePack == anotherMessagePack, @"messagePack instance is not a singleton.");
    STAssertFalse([messagePack isEqual:anotherMessagePack], @"messagePack instance is not a singleton.");
}

- (void)testPackToData
{
    MessagePack *messagePack = [MessagePack messagePack];
    
    {
        NSData *result = [messagePack packToData:nil];
        STAssertNil(result, @"Packing nil object returns nil.");
    }
}

- (void)testUnpackData
{
    MessagePack *messagePack = [MessagePack messagePack];
    
    {
        id result = [messagePack unpackData:nil];
        STAssertNil(result, @"Unpacking nil data returns nil.");
    }
    {
        NSData *blankData = [NSMutableData dataWithLength:0];
        id result = [messagePack unpackData:blankData];
        STAssertNil(result, @"Unpacking blank data returns nil.");
    }
}

@end
